﻿namespace EGRemoteStudio
{
    /// <summary> The class representing an android device </summary>
    public class Device
    {
        /// <summary> Gets the reg id. </summary>
        /// <value> The reg id. </value>
        public string RegId { get; private set; }

        /// <summary> Gets the model. </summary>
        /// <value> The model. </value>
        public string Model { get; private set; }

        /// <summary> Gets the manufacturer. </summary>
        /// <value> The manufacturer. </value>
        public string Manufacturer { get; private set; }

        /// <summary> Gets the app version. </summary>
        /// <value> The app version. </value>
        public int AppVersion { get; private set; }

        /// <summary> Gets the port used for network gateway. </summary>
        /// <value> The port. </value>
        public int Port { get; private set; }

        /// <summary> Initializes a new instance of the <see cref="Device" /> class. </summary>
        /// <param name="regId">The reg id.</param>
        /// <param name="model">The model.</param>
        /// <param name="manufacturer">The manufacturer.</param>
        /// <param name="appVersion">The app vers.</param>
        /// <param name="port">The port.</param>
        public Device(string regId, string model, string manufacturer, int appVersion, int port)
        {
            RegId = regId;
            Model = model;
            Manufacturer = manufacturer;
            AppVersion = appVersion;
            Port = port;
        }

        /// <summary> Changes the reg id. This may happen when the GCM server generated a new id </summary>
        /// <param name="newRegId">The new reg id.</param>
        public void ChangeRegId (string newRegId)
        {
            RegId = newRegId;
        }
    }
}
