﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Windows.Forms;
using WeifenLuo.WinFormsUI.Docking;

namespace EGRemoteStudio.Forms
{
    public partial class DeviceListPanel : DockContent
    {
        public event EventHandler DeviceListClear;

        public DeviceListPanel()
        {
            InitializeComponent();
        }

        public void UpdateList (List<Device> deviceList)
        {
            UpdateGui(() =>
            {
                deviceListView.Items.Clear();

                foreach (Device device in deviceList)
                {
                    ListViewItem listViewItem = new ListViewItem(new[]
                        {
                            deviceListView.Items.Count.ToString(CultureInfo.InvariantCulture),
                            device.Manufacturer + " " + device.Model, "127.0.0.1:" + device.Port.ToString()
                        });
                    deviceListView.Items.Add(listViewItem);
                }
            });
        }

        private void clearListToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (DeviceListClear != null)
                DeviceListClear(this, new EventArgs());
        }

        private void UpdateGui(Action a)
        {
            if (InvokeRequired)
                BeginInvoke(a);
            else
                a();
        }
    }
}
