﻿using System;
using System.Windows.Forms;
using EGRemoteStudio.Log;
using WeifenLuo.WinFormsUI.Docking;

namespace EGRemoteStudio.Forms
{
    public partial class LogPanel : DockContent
    {
        private RingBuffer<LogMessage> buffer;

        public LogPanel()
        {
            InitializeComponent();

            buffer = new RingBuffer<LogMessage>(50);
        }

        public void AddLogMessage(LogMessage message)
        {

            buffer.Add(message);

            Redraw();
        }

        private void Redraw()
        {
           UpdateGui(() =>
               {
                   listView1.Items.Clear();
                   for (int i = buffer.Count - 1; i >= 0; i--)
                   {
                       listView1.Items.Add(
                           new ListViewItem(new[] { buffer[i].TimeStamp, buffer[i].Device, buffer[i].Event, buffer[i].Payload }));
                   }
               });
        }

        private void UpdateGui(Action a)
        {
            if (InvokeRequired)
                BeginInvoke(a);
            else
                a();
        }
    }
}
