﻿using System.Windows.Forms;
using EGRemoteStudio.Properties;

namespace EGRemoteStudio.Forms
{
    public partial class SettingsDialog : Form
    {
        private readonly Settings.Settings settings;

        public SettingsDialog(Settings.Settings settings)
        {
            InitializeComponent();

            this.settings = settings;

            propertyGridEx1.Item.Add("Device Registration Port", settings.Port, false, "Network", "Port used to listen for new devices." +
                                                                              "(configured on settings tab in EGRemote)", true);

            propertyGridEx1.Refresh();
        }

        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            settings.Port = (int) propertyGridEx1.Item[0].Value;

            base.OnClosing(e);
        }
    }
}
